--Exercice 1
--   Question1
--      La Fonction Bidule Prend En Entre Un T_Vecteur.
--      La Premire Boucle 'FOR' Permet De Rcuprer La Valeur De La Plus Petite Composante Du Vecteur. On la stocke dans "Toto".
--      La Deuxime Boucle 'FOR' Permet De Rcuprer La Valeur De La Plus Grande Composante Du Vecteur. On la stocke dans "Tata".
--      On Retourne Alors La Moyenne Pondre De Ces Deux Valeurs.
--      Cette Fonction permet donc de rcuprer la moyenne du min et du max des composantes d'un vecteur.

--   Question2
--      Cette Fonciton N'Est Pas Optimise, Car Pour Dterminer Le 'Min' Et Le 'Max' On Parcourt Deux Fois Le Vecteur.
--      Afin De Ne Parcourir Qu'Un Seule Fois Le Vecteur, On Pourrait Faire Le Test Du Min ET Le Test Du Max Dans La Mme Boucle.
--      De plus, si le min (toto) est modifi, alors le max (tata), ne l'est pas : on peut utiliser le Elsif;
--      On Obtiendrait Alors Ceci :
--
--         FOR Indice IN Vecteur'RANGE LOOP
--            IF(Vecteur(Indice)<Toto)THEN
--               Toto := Vecteur(Indice);
--            ELSIF(Vecteur(Indice)>Tata)THEN
--               Tata := Vecteur(Indice);
--            ELSE
--               null;
--            END IF;
--         END LOOP;
--         return (Toto + Tata)/2;
--
--   Question3
--         Si L'On Voulait Adapter Cette Fonction Pour Une Matrice, Il Faudrait Que L'On Parcourt Toutes Les Composantes De La Matrice.
--         Il Faudrait Donc Utiliser Deux Boucles 'FOR' Imbriques. Voici Ce Que L'On Obtiendrait :
--
--            FOR IndiceLigne IN 1 .. Matrice.NbLigne LOOP
--               FOR IndiceColonne IN 1 .. Matrice.NbColonne LOOP
--                  IF(Matrice.Tab(IndiceLigne,IndiceColonne)<Toto)THEN
--                     Toto := Vecteur(Indice);
--                  ELSIF(Vecteur(IndiceLigne,IndiceColonne)>Tata)THEN
--                     Tata := Vecteur(Indice);
--                  ELSE
--                     null;
--                  END iF;
--               END LOOP;
--            END LOOP;
--            RETURN (Toto+Tata)/2;
--
--Exercice 2


--   Question7
--         Une Amlioration Pour Acclerer L'Insertion D'Un Auteur Dans Une Liste Serait D'Utiliser Une Liste Trie Par Ordre Alphabtique.
--         Ainsi, Si Le Nom Du Prochain Auteur Dans La Liste Se Trouve tre Aprs Dans L'Ordre Alphabtique Que L'Auteur  Ajouter,
--         Il N'Y A Plus Besoin De Continuer  Parcourir La Liste, On Sait Que Le Nouvel Auteur N'Existe Pas Encore.
--         De Plus, Pour Respecter L'Ordre Alphabtique, Il Faut Ajouter Le Nouvel Auteur  La Position  Laquelle Nous Nous Trouvons.
--         L'Implmentation De Cette Nouvelle Procdure Serait Faite Dans La Procdure 'InsertionOptimisee'.
   





WITH Ada.Text_IO;
USE Ada.Text_IO;
WITH Ada.Integer_Text_IO;
USE Ada.Integer_Text_IO;


PROCEDURE ThibaultCoudert IS
   
-----------*********************Debut de la dfinition des types utiliss*********************-----------


   -- Cette constante dfinie l taille maximum que peut prendre la concatnation du nom et du prnom
   Taille_Nom_Prenom : CONSTANT Integer := 30;



   -- Ce sous-type permet de rcuprer le choix saisi par l'utilisateur
   SUBTYPE T_Choix IS Natural RANGE 1 .. 3;



   -- Cette structure permet de renseigner les champs necessaires  un auteur
   -- On a besoin d'un String qui stocke la concatnation du nom et du prnom de l'auteur
   -- On stocke galement la longueur exacte du string 
   -- On stocke enfin le nombre de livres vendus par cet auteur
   TYPE T_Auteur IS
      RECORD
         Nom_Prenom          : String (1 .. Taille_Nom_Prenom)      := (OTHERS => ' ');
         Longueur_Nom_Prenom : Integer RANGE 0 .. Taille_Nom_Prenom;
         NbVentes            : Integer                              := 0;
      END RECORD;




   -- Le type T_Element correspond  une cellule d'un liste chainee
   -- Le type T_Liste est un pointeur sur T_Element
   TYPE T_Element;
   TYPE T_Liste IS ACCESS T_Element;



   -- Dans chaque cellule de la liste chainee, on a besoin d'un T_Auteur 
   -- ainsi qu'un pointeur sur la prochaine cellule
   TYPE T_Element IS
      RECORD
         Auteur  : T_Auteur;
         Suivant : T_Liste;
      END RECORD;





-----------*********************Debut de l'implmentation des fonctions et procedures utiliss*********************-----------



   -------------------Procedure Presentation qui affiche le menu du programme-------------------------
   -- L'utilisateur a 3 choix possibles : 2 types d'insertion et la possibilit de quitter-------
   ---------------------------------------------------------------------------------------------------
   PROCEDURE Presentation IS
   BEGIN
      Put_Line("-------------------------------------------------");
      Put_Line("-------------------------------------------------");
      Put_Line("Bienvenue dans la programme d'archivage de ventes");
      New_Line;
      Put_Line("         1 : Insertion Classique");
      Put_Line("         2 : Insertion Optimisee");
      Put_Line("         3 : Exit");
      Put_Line("-------------------------------------------------");
      Put_Line("-------------------------------------------------");
   END PResentation;
   ------------------------------------------------------------------------




   ---------------Procedure SaisirChoix qui permet  l'utilisateur d'entrer son choix-----------------
   --------------Le choix se prsente sous la forme d'un entier compris entre 1 et 3------------------
   ---------------------------------------------------------------------------------------------------
   FUNCTION SaisirMode (
         Str : String)
     RETURN T_Choix IS
      Ch : T_Choix;
   BEGIN
      Put_Line(Str); -- On ecrit le string passe en argument
      Get(Ch); -- On recupere le choix de l'utilisateur
      Skip_Line; -- On passe  la ligne
      RETURN Ch; -- On renvoie le choix saisi par l'utilisateur
   END SaisirMode;







   -- Cette procedure permet d'ajouter un auteur dans une liste chainee d'auteurs en evitant les doublons
   -- Si l'auteur existe deja on se contente de mettre a jour ses donnees (incrementation du nbr de ventes)
   -- Si l'auteur n'existe pas, on l'ajoute en debut de liste
   PROCEDURE InsererSansDoublons (
         Aut   : IN     String;
         L     : IN     Integer;
         Liste : IN OUT T_Liste) IS
      Aux         : T_Liste := Liste;
      Existe_Deja : Boolean := False;
   BEGIN

      WHILE (Aux/=NULL) LOOP -- Tant que l'on n'est pas a la fin de liste
         IF( Aut(1 .. L) = Aux.Auteur.Nom_Prenom(1 .. Aux.Auteur.Longueur_Nom_Prenom) )THEN -- Si l'auteur xiste dj
            Aux.Auteur.NbVentes := Aux.Auteur.NbVentes + 1 ; -- on incrmente son Nombre de Ventes
            Existe_Deja := True; -- Le boolean 'Existe_Deja' deivient vrai puisque l'on a trouv l'auteur
            EXIT; -- On sort de la boucle
         END IF;
         Aux := Aux.Suivant;
      END LOOP;

      IF(NOT Existe_Deja)THEN -- Si on n'a pas trouv l'auteur dans la liste
         Aux := NEW T_Element; -- Le pointeur Aux pointe sur un nouveau T_Element
         Aux.Auteur.Nom_Prenom(1 .. L) := Aut(1 .. L); -- On remplie les donnes
         Aux.Auteur.Longueur_Nom_Prenom := L;
         Aux.Auteur.NbVentes := 1;
         Aux.Suivant := Liste; -- On ajoute ce nouvel element en dbut de liste
         Liste := Aux;
      END IF;

   END InsererSansDoublons;






   -- Cette procedure permet d'ajouter un auteur dans une liste chainee et triee d'auteurs en evitant les doublons
   -- Si l'auteur existe deja on se contente de mettre a jour ses donnees (incrementation du nbr de ventes)
   -- Si l'auteur n'existe pas, on l'ajoute  la bonne place afin de garder le trie par ordre alphabtique

   PROCEDURE InsererOptimisee (
         Aut   : IN     String;
         L     : IN     Integer;
         Liste : IN OUT T_Liste) IS
      Aux        : T_Liste := Liste;
      AuxSuivant : T_Liste := Liste;
   BEGIN


      IF(Aux=NULL)THEN -- Si la liste est vide

         Aux := NEW T_Element; -- Le pointeur Aux pointe sur un nouveau T_Element
         Aux.Auteur.Nom_Prenom(1 .. L) := Aut(1 .. L); -- On remplie les donnes
         Aux.Auteur.Longueur_Nom_Prenom := L;
         Aux.Auteur.NbVentes := 1;
         Aux.Suivant := NULL; -- Il n'y a qu'un seul lment => le suivant de notre nouvel lment est null
         Liste := Aux; -- Liste pointe dornavant sur le nouvel lment



      ELSIF(Aux.Auteur.Nom_Prenom(1..Aux.Auteur.Longueur_Nom_Prenom)>Aut(1..L))THEN -- Si Le nouvel lment est avant, dans l'ordre alphabtique, le premier lment de la Liste
         -- L'lment n'xiste pas encore et il faut donc l'ajouter au dbut

         Aux := NEW T_Element; -- Le pointeur Aux pointe sur un nouveau T_Element
         Aux.Auteur.Nom_Prenom(1 .. L) := Aut(1 .. L); -- On remplie les donnes
         Aux.Auteur.Longueur_Nom_Prenom := L;
         Aux.Auteur.NbVentes := 1;
         Aux.Suivant := Liste; -- On ajoute ce nouvel element en dbut de liste
         Liste := Aux;

      ELSIF(Aux.Auteur.Nom_Prenom(1..Aux.Auteur.Longueur_Nom_Prenom)=Aut(1..L))THEN -- Si Le nouvel lment est gal au premier lment de la Liste
         -- L'lment xiste dja et il faut mettre  jour les donnes

         Aux.Auteur.NbVentes := Aux.Auteur.NbVentes + 1 ; -- on incrmente son Nombre de Ventes


      ELSE -- Dans les autres cas

         AuxSuivant := Aux.Suivant; -- AuxSuivant point sur la cellule qui suit Aux

         WHILE (AuxSuivant/=NULL) LOOP -- Tant que AuxSuivant n'est pas null (donc qu'on a pas parcouru toute la liste)

            IF( Aut(1 .. L) = AuxSuivant.Auteur.Nom_Prenom(1 .. AuxSuivant.Auteur.Longueur_Nom_Prenom) )THEN -- Si l'auteur xiste dj
               AuxSuivant.Auteur.NbVentes := AuxSuivant.Auteur.NbVentes + 1 ; -- on incrmente son Nombre de Ventes
               EXIT; -- On sort de la boucle

            ELSIF(Aut(1 .. L) < AuxSuivant.Auteur.Nom_Prenom(1 .. AuxSuivant.Auteur.Longueur_Nom_Prenom))THEN -- Si l'auteur ne peut pas tre prsent dans la liste
                                                                                                -- et doit se trouver juste aprs 'Aux'
               AuxSuivant := NEW T_Element; -- Le pointeur Aux pointe sur un nouveau T_Element
               AuxSuivant.Auteur.Nom_Prenom(1 .. L) := Aut(1 .. L); -- On remplie les donnes
               AuxSuivant.Auteur.Longueur_Nom_Prenom := L;
               AuxSuivant.Auteur.NbVentes := 1;
               AuxSuivant.Suivant := Aux.Suivant; -- On ajoute ce nouvel element entre le pointeur aux et son suivant.
               Aux.Suivant := AuxSuivant;
               EXIT; -- On sort de la boucle

            END IF;
            
            Aux := AuxSuivant; -- Les deux pointeurs se dplacent pour pointer sur les cellules qui les suivent
            AuxSuivant := Aux.Suivant; 

         END LOOP;

         IF(AuxSuivant=NULL)THEN -- Si on n'a pas trouv l'auteur dans la liste et qu'il doit se positionner en dernire position

            AuxSuivant := NEW T_Element; -- Le pointeur Aux pointe sur un nouveau T_Element
            AuxSuivant.Auteur.Nom_Prenom(1 .. L) := Aut(1 .. L); -- On remplie les donnes
            AuxSuivant.Auteur.Longueur_Nom_Prenom := L;
            AuxSuivant.Auteur.NbVentes := 1;
            AuxSuivant.Suivant := Aux.Suivant; -- On ajoute ce nouvel element aprs le poiteur aux mais avant le pointeur aux.suivant
            Aux.Suivant := AuxSuivant;

         END IF;

      END IF;

   END InsererOptimisee;






   -- Cette procedure permet de lire les informations d'un fichier qui possde l'enregistrement du nombre de ventes d'ouvrage
   -- en utilisant la fonction d'insertion normale
   PROCEDURE LireFichier (
         NomFichier : IN     String;
         Liste      : IN OUT T_Liste) IS
      Buffer   : File_Type;
      Ligne    : String (1 .. Taille_Nom_Prenom);
      Longueur : Integer;
   BEGIN

      Open(
         File => Buffer,
         Mode => In_File,
         Name => NomFichier); -- On ouvre le fichier des ventes mensuelles
      WHILE(NOT End_Of_File(Buffer))LOOP -- Tant que l'on arrive pas  la fin du fichier
         Get_Line(Buffer,Ligne,Longueur); -- On rcupre une ligne(contenant le nom et le prnom d'un l'auteur), ainsi que la longueur de la ligne
         InsererSansDoublons(Ligne,Longueur,Liste);-- On appelle la procedure InsererSansDoublons sur l'auteur en question
      END LOOP;
      Close(Buffer);--On referme le fichier
   END LireFichier;





   -- Cette procedure permet de lire les informations d'un fichier qui possde l'enregistrement du nombre de ventes d'ouvrage
   -- en utilisant la fonction d'insertion optimisee
   PROCEDURE LireFichierOptimisee (
         NomFichier : IN     String;
         Liste      : IN OUT T_Liste) IS
      Buffer   : File_Type;
      Ligne    : String (1 .. Taille_Nom_Prenom);
      Longueur : Integer;
   BEGIN

      Open(
         File => Buffer,
         Mode => In_File,
         Name => NomFichier); -- On ouvre le fichier des ventes mensuelles
      WHILE(NOT End_Of_File(Buffer))LOOP -- Tant que l'on arrive pas  la fin du fichier
         Get_Line(Buffer,Ligne,Longueur); -- On rcupre une ligne(contenant le nom et le prnom d'un l'auteur), ainsi que la longueur de la ligne
         InsererOptimisee(Ligne,Longueur,Liste);-- On appelle la procedure InsererOptimisee
      END LOOP;
      Close(Buffer);--On referme le fichier
   END LireFichierOptimisee;






   -- Cette procedure permet d'ecrire les informations contenues dans une liste chainee dans un fichier
   PROCEDURE Archiver (
         NomFichier : IN     String;
         Liste      : IN     T_Liste) IS
      Buffer : File_Type;
      Aux    : T_Liste   := Liste;
   BEGIN
      Create(
         File => Buffer,
         Name => NomFichier); -- On cre le fichier d'archivage
      WHILE(Aux/=NULL)LOOP -- Tant que l'on a pas ajout tous les lments de la liste

         Put(Buffer,Aux.Auteur.Nom_Prenom(1 .. Aux.Auteur.Longueur_Nom_Prenom)); -- On crit le nom et le prenom de l'auteur
         Put(Buffer," "); -- On ajoute un espace
         Put(Buffer,Aux.Auteur.NbVentes,0); -- On ecrit le nombre de vente
         New_Line(Buffer); -- On passe  la ligne
         Aux := Aux.All.Suivant;

      END LOOP;
      Close(Buffer); -- On ferme le fichier
   END Archiver;







-----------*********************Debut de la dclaration des variables utiliss*********************-----------
   Liste       : T_Liste;
   Origine     : String  := "VentesMensuelles.txt"; -- On suppose que les donnes enregistres se trouvent dans le fichier VantesMensuelles.txt
                                                    -- En effet, dans le dossier se trouve un fichier de ce nom avec un jeu d'exemples.
   Destination : String  := "Archivage.txt"; -- On choisie d'archiver les donnes de la liste dans le fichier Archivage.txt
   Choix       : T_Choix;
   




-----------*********************Debut du corps de la procedure principale*********************-----------
BEGIN
   LOOP
      Presentation;
      Choix := SaisirMode("Veuillez saisir votre choix ...");
      CASE CHOIX IS
         WHEN 1 =>
            LireFichier(Origine,Liste);
         WHEN 2 =>
            LireFichierOptimisee(Origine,Liste);
         WHEN 3=>
            EXIT;
      END CASE;
      Archiver(Destination,Liste);
      Put_Line("Fichier archiver avec succes");
      New_Line;
      New_Line;
      New_Line;
      New_Line;
      New_Line;
   END LOOP;
END ThibaultCoudert;























